package de.mdelab.mlsdm.diagram.providers;

import java.util.HashSet;
import java.util.IdentityHashMap;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;

import de.mdelab.mlcallactions.MlcallactionsPackage;
import de.mdelab.mlexpressions.MlexpressionsPackage;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityEdgeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityFinalNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityFinalNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.AttributeAssignmentEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.CallActionExpression2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.CallActionExpression3EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.CallActionExpressionEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ContainmentLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.DecisionMergeNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.DecisionMergeNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionActivityNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionActivityNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.FlowFinalNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.FlowFinalNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ForkJoinNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ForkJoinNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.InitialNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.InitialNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.LinkOrderConstraintEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MLStringExpression2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MLStringExpression3EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MLStringExpressionEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MapEntryLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MapEntryLinkValueTargetEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPattern2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternObjectEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StructuredNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StructuredNodeEditPart;
import de.mdelab.mlsdm.diagram.part.MlsdmDiagramEditorPlugin;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;

/**
 * @generated
 */
public class MlsdmElementTypes
{

	/**
	 * @generated
	 */
	private MlsdmElementTypes()
	{
	}

	/**
	 * @generated
	 */
	private static Map<IElementType, ENamedElement>	elements;

	/**
	 * @generated
	 */
	private static ImageRegistry					imageRegistry;

	/**
	 * @generated
	 */
	private static Set<IElementType>				KNOWN_ELEMENT_TYPES;

	/**
	 * @generated
	 */
	public static final IElementType				Activity_1000					= getElementType("de.mdelab.mlsdm.diagram.Activity_1000");					//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				ActivityFinalNode_2002			= getElementType("de.mdelab.mlsdm.diagram.ActivityFinalNode_2002");		//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				DecisionMergeNode_2006			= getElementType("de.mdelab.mlsdm.diagram.DecisionMergeNode_2006");		//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				ExpressionActivityNode_2001		= getElementType("de.mdelab.mlsdm.diagram.ExpressionActivityNode_2001");	//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				FlowFinalNode_2007				= getElementType("de.mdelab.mlsdm.diagram.FlowFinalNode_2007");			//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				ForkJoinNode_2003				= getElementType("de.mdelab.mlsdm.diagram.ForkJoinNode_2003");				//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				InitialNode_2004				= getElementType("de.mdelab.mlsdm.diagram.InitialNode_2004");				//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				StoryNode_2008					= getElementType("de.mdelab.mlsdm.diagram.StoryNode_2008");				//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				StructuredNode_2009				= getElementType("de.mdelab.mlsdm.diagram.StructuredNode_2009");			//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				MLStringExpression_3001			= getElementType("de.mdelab.mlsdm.diagram.MLStringExpression_3001");		//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				CallActionExpression_3013		= getElementType("de.mdelab.mlsdm.diagram.CallActionExpression_3013");		//$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType				StoryPattern_3002				= getElementType("de.mdelab.mlsdm.diagram.StoryPattern_3002");				//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				StoryPatternObject_3003			= getElementType("de.mdelab.mlsdm.diagram.StoryPatternObject_3003");		//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				MLStringExpression_3004			= getElementType("de.mdelab.mlsdm.diagram.MLStringExpression_3004");		//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				AttributeAssignment_3005		= getElementType("de.mdelab.mlsdm.diagram.AttributeAssignment_3005");		//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				CallActionExpression_3012		= getElementType("de.mdelab.mlsdm.diagram.CallActionExpression_3012");		//$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType				MLStringExpression_3014			= getElementType("de.mdelab.mlsdm.diagram.MLStringExpression_3014");		//$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType				CallActionExpression_3015		= getElementType("de.mdelab.mlsdm.diagram.CallActionExpression_3015");		//$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType				StoryPattern_3017				= getElementType("de.mdelab.mlsdm.diagram.StoryPattern_3017");				//$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType				DecisionMergeNode_3006			= getElementType("de.mdelab.mlsdm.diagram.DecisionMergeNode_3006");		//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				ExpressionActivityNode_3007		= getElementType("de.mdelab.mlsdm.diagram.ExpressionActivityNode_3007");	//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				FlowFinalNode_3008				= getElementType("de.mdelab.mlsdm.diagram.FlowFinalNode_3008");			//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				ForkJoinNode_3009				= getElementType("de.mdelab.mlsdm.diagram.ForkJoinNode_3009");				//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				InitialNode_3010				= getElementType("de.mdelab.mlsdm.diagram.InitialNode_3010");				//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				StoryNode_3011					= getElementType("de.mdelab.mlsdm.diagram.StoryNode_3011");				//$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType				StructuredNode_3018				= getElementType("de.mdelab.mlsdm.diagram.StructuredNode_3018");			//$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType				ActivityFinalNode_3019			= getElementType("de.mdelab.mlsdm.diagram.ActivityFinalNode_3019");		//$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType				ActivityEdge_4001				= getElementType("de.mdelab.mlsdm.diagram.ActivityEdge_4001");				//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				StoryPatternLink_4002			= getElementType("de.mdelab.mlsdm.diagram.StoryPatternLink_4002");			//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				ContainmentLink_4003			= getElementType("de.mdelab.mlsdm.diagram.ContainmentLink_4003");			//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				ExpressionLink_4004				= getElementType("de.mdelab.mlsdm.diagram.ExpressionLink_4004");			//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				LinkOrderConstraint_4005		= getElementType("de.mdelab.mlsdm.diagram.LinkOrderConstraint_4005");		//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				MapEntryLink_4006				= getElementType("de.mdelab.mlsdm.diagram.MapEntryLink_4006");				//$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType				MapEntryLinkValueTarget_4007	= getElementType("de.mdelab.mlsdm.diagram.MapEntryLinkValueTarget_4007");	//$NON-NLS-1$

	/**
	 * @generated
	 */
	private static ImageRegistry getImageRegistry()
	{
		if (imageRegistry == null)
		{
			imageRegistry = new ImageRegistry();
		}
		return imageRegistry;
	}

	/**
	 * @generated
	 */
	private static String getImageRegistryKey(ENamedElement element)
	{
		return element.getName();
	}

	/**
	 * @generated
	 */
	private static ImageDescriptor getProvidedImageDescriptor(ENamedElement element)
	{
		if (element instanceof EStructuralFeature)
		{
			EStructuralFeature feature = ((EStructuralFeature) element);
			EClass eContainingClass = feature.getEContainingClass();
			EClassifier eType = feature.getEType();
			if (eContainingClass != null && !eContainingClass.isAbstract())
			{
				element = eContainingClass;
			}
			else if (eType instanceof EClass && !((EClass) eType).isAbstract())
			{
				element = eType;
			}
		}
		if (element instanceof EClass)
		{
			EClass eClass = (EClass) element;
			if (!eClass.isAbstract())
			{
				return MlsdmDiagramEditorPlugin.getInstance().getItemImageDescriptor(
						eClass.getEPackage().getEFactoryInstance().create(eClass));
			}
		}
		// TODO : support structural features
		return null;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(ENamedElement element)
	{
		String key = getImageRegistryKey(element);
		ImageDescriptor imageDescriptor = getImageRegistry().getDescriptor(key);
		if (imageDescriptor == null)
		{
			imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null)
			{
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
		}
		return imageDescriptor;
	}

	/**
	 * @generated
	 */
	public static Image getImage(ENamedElement element)
	{
		String key = getImageRegistryKey(element);
		Image image = getImageRegistry().get(key);
		if (image == null)
		{
			ImageDescriptor imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null)
			{
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
			image = getImageRegistry().get(key);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(IAdaptable hint)
	{
		ENamedElement element = getElement(hint);
		if (element == null)
		{
			return null;
		}
		return getImageDescriptor(element);
	}

	/**
	 * @generated
	 */
	public static Image getImage(IAdaptable hint)
	{
		ENamedElement element = getElement(hint);
		if (element == null)
		{
			return null;
		}
		return getImage(element);
	}

	/**
	 * Returns 'type' of the ecore object associated with the hint.
	 * 
	 * @generated
	 */
	public static ENamedElement getElement(IAdaptable hint)
	{
		Object type = hint.getAdapter(IElementType.class);
		if (elements == null)
		{
			elements = new IdentityHashMap<IElementType, ENamedElement>();

			elements.put(Activity_1000, MlsdmPackage.eINSTANCE.getActivity());

			elements.put(ActivityFinalNode_2002, MlsdmPackage.eINSTANCE.getActivityFinalNode());

			elements.put(DecisionMergeNode_2006, MlsdmPackage.eINSTANCE.getDecisionMergeNode());

			elements.put(ExpressionActivityNode_2001, MlsdmPackage.eINSTANCE.getExpressionActivityNode());

			elements.put(FlowFinalNode_2007, MlsdmPackage.eINSTANCE.getFlowFinalNode());

			elements.put(ForkJoinNode_2003, MlsdmPackage.eINSTANCE.getForkJoinNode());

			elements.put(InitialNode_2004, MlsdmPackage.eINSTANCE.getInitialNode());

			elements.put(StoryNode_2008, MlsdmPackage.eINSTANCE.getStoryNode());

			elements.put(StructuredNode_2009, MlsdmPackage.eINSTANCE.getStructuredNode());

			elements.put(MLStringExpression_3001, MlexpressionsPackage.eINSTANCE.getMLStringExpression());

			elements.put(CallActionExpression_3013, MlcallactionsPackage.eINSTANCE.getCallActionExpression());

			elements.put(StoryPattern_3002, MlstorypatternsPackage.eINSTANCE.getStoryPattern());

			elements.put(StoryPatternObject_3003, MlstorypatternsPackage.eINSTANCE.getStoryPatternObject());

			elements.put(MLStringExpression_3004, MlexpressionsPackage.eINSTANCE.getMLStringExpression());

			elements.put(AttributeAssignment_3005, MlstorypatternsPackage.eINSTANCE.getAttributeAssignment());

			elements.put(CallActionExpression_3012, MlcallactionsPackage.eINSTANCE.getCallActionExpression());

			elements.put(MLStringExpression_3014, MlexpressionsPackage.eINSTANCE.getMLStringExpression());

			elements.put(CallActionExpression_3015, MlcallactionsPackage.eINSTANCE.getCallActionExpression());

			elements.put(StoryPattern_3017, MlstorypatternsPackage.eINSTANCE.getStoryPattern());

			elements.put(DecisionMergeNode_3006, MlsdmPackage.eINSTANCE.getDecisionMergeNode());

			elements.put(ExpressionActivityNode_3007, MlsdmPackage.eINSTANCE.getExpressionActivityNode());

			elements.put(FlowFinalNode_3008, MlsdmPackage.eINSTANCE.getFlowFinalNode());

			elements.put(ForkJoinNode_3009, MlsdmPackage.eINSTANCE.getForkJoinNode());

			elements.put(InitialNode_3010, MlsdmPackage.eINSTANCE.getInitialNode());

			elements.put(StoryNode_3011, MlsdmPackage.eINSTANCE.getStoryNode());

			elements.put(StructuredNode_3018, MlsdmPackage.eINSTANCE.getStructuredNode());

			elements.put(ActivityFinalNode_3019, MlsdmPackage.eINSTANCE.getActivityFinalNode());

			elements.put(ActivityEdge_4001, MlsdmPackage.eINSTANCE.getActivityEdge());

			elements.put(StoryPatternLink_4002, MlstorypatternsPackage.eINSTANCE.getStoryPatternLink());

			elements.put(ContainmentLink_4003, MlstorypatternsPackage.eINSTANCE.getContainmentLink());

			elements.put(ExpressionLink_4004, MlstorypatternsPackage.eINSTANCE.getExpressionLink());

			elements.put(LinkOrderConstraint_4005, MlstorypatternsPackage.eINSTANCE.getLinkOrderConstraint());

			elements.put(MapEntryLink_4006, MlstorypatternsPackage.eINSTANCE.getMapEntryLink());

			elements.put(MapEntryLinkValueTarget_4007, MlstorypatternsPackage.eINSTANCE.getMapEntryLink_ValueTarget());
		}
		return (ENamedElement) elements.get(type);
	}

	/**
	 * @generated
	 */
	private static IElementType getElementType(String id)
	{
		return ElementTypeRegistry.getInstance().getType(id);
	}

	/**
	 * @generated
	 */
	public static boolean isKnownElementType(IElementType elementType)
	{
		if (KNOWN_ELEMENT_TYPES == null)
		{
			KNOWN_ELEMENT_TYPES = new HashSet<IElementType>();
			KNOWN_ELEMENT_TYPES.add(Activity_1000);
			KNOWN_ELEMENT_TYPES.add(ActivityFinalNode_2002);
			KNOWN_ELEMENT_TYPES.add(DecisionMergeNode_2006);
			KNOWN_ELEMENT_TYPES.add(ExpressionActivityNode_2001);
			KNOWN_ELEMENT_TYPES.add(FlowFinalNode_2007);
			KNOWN_ELEMENT_TYPES.add(ForkJoinNode_2003);
			KNOWN_ELEMENT_TYPES.add(InitialNode_2004);
			KNOWN_ELEMENT_TYPES.add(StoryNode_2008);
			KNOWN_ELEMENT_TYPES.add(StructuredNode_2009);
			KNOWN_ELEMENT_TYPES.add(MLStringExpression_3001);
			KNOWN_ELEMENT_TYPES.add(CallActionExpression_3013);
			KNOWN_ELEMENT_TYPES.add(StoryPattern_3002);
			KNOWN_ELEMENT_TYPES.add(StoryPatternObject_3003);
			KNOWN_ELEMENT_TYPES.add(MLStringExpression_3004);
			KNOWN_ELEMENT_TYPES.add(AttributeAssignment_3005);
			KNOWN_ELEMENT_TYPES.add(CallActionExpression_3012);
			KNOWN_ELEMENT_TYPES.add(MLStringExpression_3014);
			KNOWN_ELEMENT_TYPES.add(CallActionExpression_3015);
			KNOWN_ELEMENT_TYPES.add(StoryPattern_3017);
			KNOWN_ELEMENT_TYPES.add(DecisionMergeNode_3006);
			KNOWN_ELEMENT_TYPES.add(ExpressionActivityNode_3007);
			KNOWN_ELEMENT_TYPES.add(FlowFinalNode_3008);
			KNOWN_ELEMENT_TYPES.add(ForkJoinNode_3009);
			KNOWN_ELEMENT_TYPES.add(InitialNode_3010);
			KNOWN_ELEMENT_TYPES.add(StoryNode_3011);
			KNOWN_ELEMENT_TYPES.add(StructuredNode_3018);
			KNOWN_ELEMENT_TYPES.add(ActivityFinalNode_3019);
			KNOWN_ELEMENT_TYPES.add(ActivityEdge_4001);
			KNOWN_ELEMENT_TYPES.add(StoryPatternLink_4002);
			KNOWN_ELEMENT_TYPES.add(ContainmentLink_4003);
			KNOWN_ELEMENT_TYPES.add(ExpressionLink_4004);
			KNOWN_ELEMENT_TYPES.add(LinkOrderConstraint_4005);
			KNOWN_ELEMENT_TYPES.add(MapEntryLink_4006);
			KNOWN_ELEMENT_TYPES.add(MapEntryLinkValueTarget_4007);
		}
		return KNOWN_ELEMENT_TYPES.contains(elementType);
	}

	/**
	 * @generated
	 */
	public static IElementType getElementType(int visualID)
	{
		switch (visualID)
		{
			case ActivityEditPart.VISUAL_ID:
				return Activity_1000;
			case ActivityFinalNodeEditPart.VISUAL_ID:
				return ActivityFinalNode_2002;
			case DecisionMergeNodeEditPart.VISUAL_ID:
				return DecisionMergeNode_2006;
			case ExpressionActivityNodeEditPart.VISUAL_ID:
				return ExpressionActivityNode_2001;
			case FlowFinalNodeEditPart.VISUAL_ID:
				return FlowFinalNode_2007;
			case ForkJoinNodeEditPart.VISUAL_ID:
				return ForkJoinNode_2003;
			case InitialNodeEditPart.VISUAL_ID:
				return InitialNode_2004;
			case StoryNodeEditPart.VISUAL_ID:
				return StoryNode_2008;
			case StructuredNodeEditPart.VISUAL_ID:
				return StructuredNode_2009;
			case MLStringExpressionEditPart.VISUAL_ID:
				return MLStringExpression_3001;
			case CallActionExpression2EditPart.VISUAL_ID:
				return CallActionExpression_3013;
			case StoryPatternEditPart.VISUAL_ID:
				return StoryPattern_3002;
			case StoryPatternObjectEditPart.VISUAL_ID:
				return StoryPatternObject_3003;
			case MLStringExpression2EditPart.VISUAL_ID:
				return MLStringExpression_3004;
			case AttributeAssignmentEditPart.VISUAL_ID:
				return AttributeAssignment_3005;
			case CallActionExpressionEditPart.VISUAL_ID:
				return CallActionExpression_3012;
			case MLStringExpression3EditPart.VISUAL_ID:
				return MLStringExpression_3014;
			case CallActionExpression3EditPart.VISUAL_ID:
				return CallActionExpression_3015;
			case StoryPattern2EditPart.VISUAL_ID:
				return StoryPattern_3017;
			case DecisionMergeNode2EditPart.VISUAL_ID:
				return DecisionMergeNode_3006;
			case ExpressionActivityNode2EditPart.VISUAL_ID:
				return ExpressionActivityNode_3007;
			case FlowFinalNode2EditPart.VISUAL_ID:
				return FlowFinalNode_3008;
			case ForkJoinNode2EditPart.VISUAL_ID:
				return ForkJoinNode_3009;
			case InitialNode2EditPart.VISUAL_ID:
				return InitialNode_3010;
			case StoryNode2EditPart.VISUAL_ID:
				return StoryNode_3011;
			case StructuredNode2EditPart.VISUAL_ID:
				return StructuredNode_3018;
			case ActivityFinalNode2EditPart.VISUAL_ID:
				return ActivityFinalNode_3019;
			case ActivityEdgeEditPart.VISUAL_ID:
				return ActivityEdge_4001;
			case StoryPatternLinkEditPart.VISUAL_ID:
				return StoryPatternLink_4002;
			case ContainmentLinkEditPart.VISUAL_ID:
				return ContainmentLink_4003;
			case ExpressionLinkEditPart.VISUAL_ID:
				return ExpressionLink_4004;
			case LinkOrderConstraintEditPart.VISUAL_ID:
				return LinkOrderConstraint_4005;
			case MapEntryLinkEditPart.VISUAL_ID:
				return MapEntryLink_4006;
			case MapEntryLinkValueTargetEditPart.VISUAL_ID:
				return MapEntryLinkValueTarget_4007;
		}
		return null;
	}

}
